<!-- Top of page navigation table -->

<?php include "global/toplevelheader.html"; ?>

<?php
    function write_link($submission_dir, $name) {
        $final_string = "<LI><a href=\"" . $submission_dir . "/index.php\">" . $name . "</a>";
        $command = "ls $submission_dir" . '/*.msg';
        exec($command, $dir_listing);
        $num_of_messages = count($dir_listing);
        if ($num_of_messages > 0) {
            if ($num_of_messages > 1) {
                $final_string = $final_string . " (" . $num_of_messages . " messages)";
            } else {
                $final_string = $final_string . " (" . $num_of_messages . " message)";
            }
        }
        echo $final_string . "\n";
        return;
    }
?>

<table bgcolor="#FFFFFF" width="80%" align="center" cellpadding="20">
    <tr>
        <td>
            <H2>The Repository</H2>
            <p>Current number of submissions: 58</p>
            <p>If a submission has received any comments, the number of comments appears in brackets after the link.</p>
            
            <UL>
                <UL>Algorithms
                    <?php write_link("los_blocking_lines", "LOS blocking detection using intersection of line segments"); ?>
                    <?php write_link("mandelbrot", "Mandelbrot set animation example"); ?>
                    <?php write_link("numpy_circles", "Circle-drawing code, using surfarray"); ?>
                    <?php write_link("transform_scale", "Aspect-ratio preserving transform.scale"); ?>
                </UL>
                
                <UL>Effects
                    <?php write_link("numpy_flames", "A fast flame example, using surfarray"); ?>
                    <?php write_link("palette_fractals", "Palette-cycling fractal example"); ?>
                    <?php write_link("parallax_starfield", "Parallax starfield example"); ?>
                    <?php write_link("screen_dimmer", "Screen dimmer class"); ?>
                    <?php write_link("starfield_class", "Starfield class"); ?>
                    <?php write_link("3d_wireframe", "3-D Wireframe example"); ?>
                    <?php write_link("numpy_plasma", "RGB Plasma effect"); ?>
                    <?php write_link("3d_starfield", "3D Starfield example"); ?>
                    <?php write_link("splurge", "'Splurge' effect module"); ?>
                    <?php write_link("vertical_wipe", "Vertical Image Wipe Effect"); ?>
                    <?php write_link("blinds_wipe", "Blinds Transition Effect"); ?>
                    <?php write_link("rotozoom", "Bitmap Roto-Zoom Effect"); ?>
                    <?php write_link("water", "Water Effects Script"); ?>
                    <?php write_link("mosaic", "Mosaic Transition Effect"); ?>
                    <?php write_link("interference", "Interference Pattern Effect"); ?>
                    <?php write_link("motion_blur", "Motion Blur Effect"); ?>
                    <?php write_link("unlimited_sprites", "Unlimited Sprites Effect"); ?>
                    <?php write_link("acidblur", "Acidblur Effect"); ?>
                    <?php write_link("vector_bob", "'Vector-Bob' Sprite/Particle Example"); ?>
                    <?php write_link("intersection_bobs", "'Intersection_Bobs' Sprite/Zbuffer Example"); ?>
                    <?php write_link("meltdown", "Meltdown Effect"); ?>
                    <?php write_link("selfrep", "'Selfrep' Effect Script"); ?>
                </UL>

                <UL>Font Effects
                    <?php write_link("crystal_text", "Text Crystal Effect module"); ?>
                    <?php write_link("emboss_cutout", "Emboss/Cutout script"); ?>
                    <?php write_link("drop_shadow", "Dropshadow module"); ?>
                    <?php write_link("hollow_outline", "Hollow/Outline text module"); ?>
                    <?php write_link("linefill_text", "Linefill Text Module"); ?>
                    <?php write_link("progress_text", "Textual Progress Bar"); ?>
                    <?php write_link("glyph_rainbow", "Glyph Detection/Rainbow effect"); ?>
                    <?php write_link("skyscraper", "'Skyscraper' Typography script"); ?>
                    <?php write_link("static_text", "Static text module"); ?>
                    <?php write_link("wavey_text", "Wavy Text module"); ?>
                    <?php write_link("sinkblur", "Sinkblur text effect module"); ?>
                </UL>

                <UL>GUI
                    <?php write_link("error_box", "Multi-toolkit error box module"); ?>
                    <?php write_link("filename_list", "List-selection dialog"); ?>
                    <?php write_link("inputbox", "Inputbox Module"); ?>
                </UL>
                
                <UL>Sound
                    <?php write_link("cd_tutorial", "Cd-rom functionality tutorial"); ?>
                </UL>
                
                <UL>Timing
                    <?php write_link("fpsclock", "A class for frame-per-second management"); ?>
                    <?php write_link("fpstimer", "A class for fps-independent timing"); ?>
                    <?php write_link("profiler", "Code profiling class"); ?>
                </UL>
                
                <UL>Utility
                    <?php write_link("hi_score", "Interface class to a machine-wide high score file"); ?>
                    <?php write_link("text_rect", "Word-wrapped text display module"); ?>
                    <?php write_link("palette_loader", "Palette-file loading function"); ?>
                    <?php write_link("bitmap_font", "Bitmapped font module"); ?>
                    <?php write_link("box_selection", "Box Selection Tool"); ?>
                    <?php write_link("fast_digits", "Fast digit rendering class"); ?>
                    <?php write_link("load_cursors", "Cursor creation function"); ?>
                    <?php write_link("gfxcursor", "Graphical cursor class"); ?>
                    <?php write_link("userrect", "UserRect class"); ?>
                    <?php write_link("caching_resource", "Caching Resource Module"); ?>
                    <?php write_link("image2py", "Image2py Function"); ?>
                    <?php write_link("zoom_surface", "Zoom-able Surface Class"); ?>
                    <?php write_link("zipshow", "Zipfile Image Storage Example"); ?>
                    <?php write_link("vector", "2D Vector Class"); ?>
                </UL>
            </UL>
        </td>
    </tr>
</table>

<!-- End of page navigation table -->

<?php include "global/toplevelfooter.html"; ?>

